PAGE 55,132
TITLE IPL - INITIAL PROGRAM LOAD (SYSTEM REBOOT) FROM WITHIN A .BAT FILE
;
;       COPYRIGHT (C) M_SQUARED SYSTEMS INC. - 1985,1986
;
;
; NOTE: THIS CODE BYPASSES BOTH THE KEYBOARD RESET LOGIC (CRTL-ALT-DEL)
;       AND THE INT 19H REBOOT LOGIC, SINCE SOME OTHER PROGRAMS ATTEMPT
;       TO INTERCEPT ONE OR BOTH OF THESE METHODS TO RE-ISSUE SOME KIND
;       OF 'ARE YOU SURE' REPROMPT.
;

DATA    SEGMENT AT 040H
        ORG     072H
R_FLAG  DW      ?                       ;KEYBOARD RESET FLAG, '1234H'
DATA    ENDS

ROM     SEGMENT AT 0F000H
        ORG     0E05BH
RESET   LABEL   FAR                     ;BIOS IPL ADDRESS
ROM     ENDS

CSEG    SEGMENT PARA PUBLIC 'CODE'
        ASSUME  CS:CSEG,DS:DATA,ES:DATA
        PUBLIC  IPL
        ORG     100H
IPL     PROC    FAR
        MOV     AX,040H                 ;ACCESS THE BIOS DATA AREA
        MOV     DS,AX                   ;USING DS
        MOV     R_FLAG,01234H           ;MAKE SURE BIOS THINKS CTRL-ALT_DEL
        LEA     BP,DS:R_FLAG            ;AS OPPOSED TO POWER ON OR ???
        JMP     FAR PTR RESET           ;JUMP TO BIOS CODE
IPL     ENDP
CSEG    ENDS
        END     IPL
